// PV227, Tessellation Viewer
#pragma once

#include "../../Framework/PV227.h"

using namespace std;
using namespace PV227;

//---------------------
//----    SCENE    ----
//---------------------

// Shader programs
ShaderProgram IL_FOS_program;		// isolines, fractional_odd_spacing
ShaderProgram IL_FOS_PM_program;	// isolines, fractional_odd_spacing, point_mode
ShaderProgram IL_FES_program;		// isolines, fractional_even_spacing
ShaderProgram IL_FES_PM_program;	// isolines, fractional_even_spacing, point_mode
ShaderProgram IL_ES_program;		// isolines, equal_spacing
ShaderProgram IL_ES_PM_program;		// isolines, equal_spacing, point_mode
ShaderProgram T_FOS_program;		// triangles, fractional_odd_spacing
ShaderProgram T_FOS_PM_program;		// triangles, fractional_odd_spacing, point_mode
ShaderProgram T_FES_program;		// triangles, fractional_even_spacing
ShaderProgram T_FES_PM_program;		// triangles, fractional_even_spacing, point_mode
ShaderProgram T_ES_program;			// triangles, equal_spacing
ShaderProgram T_ES_PM_program;		// triangles, equal_spacing, point_mode
ShaderProgram Q_FOS_program;		// quads, fractional_odd_spacing
ShaderProgram Q_FOS_PM_program;		// quads, fractional_odd_spacing, point_mode
ShaderProgram Q_FES_program;		// quads, fractional_even_spacing
ShaderProgram Q_FES_PM_program;		// quads, fractional_even_spacing, point_mode
ShaderProgram Q_ES_program;			// quads, equal_spacing
ShaderProgram Q_ES_PM_program;		// quads, equal_spacing, point_mode

GLuint empty_vao;

// Functions that works with scene objects
void reload_shaders();
void init_scene();
void update_scene(int app_time_diff_ms);
void render_scene();

//-------------------
//----    GUI    ----
//-------------------

// Main AntTweakBar object
TwBar *the_gui;

// Variables that are changed with GUI
int primitives;
const int PRIMITIVE_ISOLINES = 0;
const int PRIMITIVE_QUADS = 1;
const int PRIMITIVE_TRIANGLES = 2;

int spacing;
const int EQUAL_SPACING = 0;
const int FRACTIONAL_EVEN_SPACING = 1;
const int FRACTIONAL_ODD_SPACING = 2;

bool point_mode;

float TessLevelInner[2];
float TessLevelOuter[4];

// Callbacks from the GUI
void TW_CALL reload(void *);

// Functions that works with GUI
void init_gui();

//---------------------------
//----    APPLICATION    ----

// Current window size
int win_width = 640;
int win_height = 480;

// Current time of the application in milliseconds, for animations
int app_time_ms = 0;
int last_glut_time = 0;
